//
//  NetworkServer.h
//  NetworkAPI
//
//  Created by Ger Teunis on 16-08-12.
//  Copyright (c) 2012 Ger Teunis. All rights reserved.
//

#import "NetworkAPIHandlerProtocol.h"
#import <Foundation/Foundation.h>
@class HTTPServer;


@interface NetworkAPIServer : NSObject {
    HTTPServer *httpServer;
    NSObject<NetworkAPIHandlerProtocol>* handler;
    NSString *documentRoot;
    ushort _tcpPort;
    NSString *remoteApiKey;
}

@property (strong) HTTPServer *httpServer;
@property (readonly) NSObject<NetworkAPIHandlerProtocol>* handler;
@property (strong) NSString *documentRoot;
@property (strong) NSString *remoteApiKey;

-(NSArray *)sslIdentityAndCertificates;
+(NetworkAPIServer*)sharedInstance;
-(void)startServer;
-(void)stopServer;
-(id)initWithHandler:(NSObject<NetworkAPIHandlerProtocol>*)h
   usingDocumentRoot:(NSString*)docroot
             tcpPort:(ushort)tcpPort
              apiKey:(NSString*)apiKey;

@end
