

var ServerHandler = ServerHandler || {

	serverURL : null,
	sessionid : null,
	apikey : null,
	authenticationFailedHandler : null,


	//generic execute operation function	
	executeOperation : function(operation, callback) {
	
		//if not auth; always add sessionid
		var isAuthenticationRequest = operation.indexOf('/auth/')>-1;
		if (!isAuthenticationRequest) {
			operation+=((operation.indexOf("?")==-1)?"?":"&")+"sessionid="+ServerHandler.sessionid;
		}
		
		var request = $.getJSON(ServerHandler.serverURL+operation);
		var resultCode = 403;
		var resultData = null;
		
		request.success(function(data) { 
			if (data.httpStatusCode) {
				resultCode = data.httpStatusCode;
				resultData = data;
			} else {
				resultCode = request.status;
				resultData = data;
			}
			
			if (resultCode==403 && !isAuthenticationRequest && ServerHandler.authenticationFailedHandler) {
				ServerHandler.authenticationFailedHandler();
			} else {
				callback(resultCode, data);
			}
		});

		request.error(function(jqXHR, textStatus, errorThrown) {
		
			resultCode = jqXHR.status;
			
			if (resultCode==403 && !isAuthenticationRequest && ServerHandler.authenticationFailedHandler) {
				ServerHandler.authenticationFailedHandler();
			} else {
				callback(resultCode, data);
			}
		});
	},



	// LOGIN
	login : function(loginResult) {
		ServerHandler.executeOperation("/auth/nonce", function(statusCode, data) {
		
			if (statusCode==200 && data.authNonce) {
				ServerHandler.loginWithDetails(data.authNonce, ServerHandler.apikey, function(result) {
					loginResult(result);
				});
			} else {
				return false;
			}
		});
	},
	
	loginWithDetails : function(nonce, sharedsecret, callback) {
		var cnonce = Math.uuid(8,16);
		var shaObj = new jsSHA(nonce+":"+cnonce+":"+sharedsecret, "ASCII");
		var hash = shaObj.getHash("SHA-256", "B64");
	
		ServerHandler.executeOperation("/auth/login?nonce="+nonce+"&cnonce="+cnonce+"&hash="+hash, function(statusCode, data) {
			if (statusCode==200 && data.loginResult=="successful") {
				ServerHandler.sessionid=data.sessionID;
				callback(true);
			} else {
				callback(false);
			}
		});
	}
}
